// Header pour les intrinsics SSE
#include <xmmintrin.h>

#include <iostream>

using namespace std;

/**
 * 
 */
float max_sse(float* array, unsigned int size) {

  unsigned int it4 = (size / 4) * 4;
  unsigned int i = 0;

  float res;

  // "registres" SSE
  __m128 r1, r2;

  // Chargement des 4 premiers flottants du tableau
  r1 = _mm_load_ps(array);

  // Tant que possible on prend les flottants 4 par 4
  for(i = 4 ; i < it4 ; i += 4) {
    // r1 contient les max du sous-tableau parcouru à l'itération précédente
    // on calcul le max entre r1 et les 4 éléments suivants
    r1 = _mm_max_ps(r1, _mm_load_ps(&(array[i])));

  }
  // S'il reste moins de 4 éléments on charge les éléments 1 par 1
  for(i = it4 ; i < size ; ++i) {

    r2 = _mm_load_ss(&array[i]);
    r1 = _mm_max_ss(r1, r2);

  }
  // A ce point, on dispose des 4 valeurs max, il reste à les comparer entre elles

  r2 = _mm_unpackhi_ps(r1, r1);
  r1 = _mm_unpacklo_ps(r1, r1);

  r1 = _mm_max_ps(r1, r2);

  r2 = _mm_unpackhi_ps(r1, r1);
  r1 = _mm_unpacklo_ps(r1, r1);

  r1 = _mm_max_ps(r1, r2);

  // On stocke le résultat en mémoire
  _mm_store_ss(&res, r1);

}


int main() {

  float a1[13] __attribute__((aligned(16))) = {1, 2, 14, 4, 6, 2, 9, 1, 8, 12, 14, 54, 98};

  cout << max_sse(a1, 13) << endl;

}
