/**
 * [a[M0], a[M1], b[M2], b[M3]] = _mm_shuffle_ps({a[0], a[1], a[2], a[3]}, {b[0], b[1], b[2], b[3]}, _MM_SHUFFLE(M3, M2, M1, M0));
 */

#include <xmmintrin.h>


#include <iostream>

using namespace std;


void display(float* v) {
  cout << v[0] << '\t' << v[1] << '\t' << v[2] << '\t' << v[3] << endl;
}


int main() {

  float a0[4] __attribute__((aligned(16))) = {1, 2, 3, 4};
  float a1[4] __attribute__((aligned(16))) = {5, 6, 7, 8};
  float a2[4] __attribute__((aligned(16)));

  __m128 r0, r1;

  display(a0);
  display(a1);

  r0 = _mm_load_ps(a0);
  r1 = _mm_load_ps(a1);

  r0 = _mm_shuffle_ps(r0, r1, _MM_SHUFFLE(3, 0, 2, 1));

  _mm_store_ps(a2, r0);

  display(a2);

}
