/**
 * [a0 + a1, a2 + a3, b0 + b1, b2 + b3] = _mm_hadd_ps([a0, a1, a2, a3], [b0, b1, b2, b3]);
 */

#include <pmmintrin.h>


#include <iostream>

using namespace std;


void display(float* v) {
  cout << v[0] << '\t' << v[1] << '\t' << v[2] << '\t' << v[3] << endl;
}
void display(int* v) {
  cout << v[0] << '\t' << v[1] << '\t' << v[2] << '\t' << v[3] << endl;
}


int main() {

  float a0[4] __attribute__((aligned(16))) = {1.1, 2.1, 3.6, 4.8};
  float a1[4] __attribute__((aligned(16))) = {0.9, 0.9, 1.4, 2.8};
  float a2[4] __attribute__((aligned(16)));

  __m128 r0, r1, r2;

  display(a0);
  display(a1);

  r0 = _mm_load_ps(a0);
  r1 = _mm_load_ps(a1);

  r2 = _mm_hadd_ps(r0, r1);

  _mm_store_ps(a2, r2);

  display(a2);

}
