/**
 * [(a0 + b0) * (a1 + b1), (a2 + b2) * (a3 + b3), ... , (a14 + b14) * (a15 + b15)] = _mm_maddubs_epi16([a0, a1, a2, a3, ..., a15], [b0, b1, b2, b3, ..., b15]);
 */

#include <tmmintrin.h>


#include <iostream>

using namespace std;


void display(char* v) {

  for(unsigned int i = 0 ; i < 16 ; ++i) {
    cout << (int)(v[i]) << '\t';
  }
  cout << endl;

}

void display(short* v) {

  for(unsigned int i = 0 ; i < 8 ; ++i) {
    cout << v[i] << '\t';
  }
  cout << endl;

}

int main() {

  char a0[16] __attribute__((aligned(16))) = {127, 1, 2, 3, 4, 5, 6, 7, 1, 2, 3, 4, 5, 6, 7, 8};
  char a1[16] __attribute__((aligned(16))) = {127, 2, 1, 0, 4, 2, 5, 9, 0, 1, 2, 3, 4, 5, 6, 7};
  short a2[8] __attribute__((aligned(16)));

  __m128i r0, r1, r2;

  display(a0);
  display(a1);

  r0 = _mm_load_si128((__m128i*)a0);
  r1 = _mm_load_si128((__m128i*)a1);

  r2 = _mm_maddubs_epi16(r0, r1);

  _mm_store_si128((__m128i*)a2, r2);

  display(a2);

}
