/**
 * [a[b0], a[b1], ..., a[b15]] = _mm_shuffle_epi8([a0, a1, a2, a3, ..., a15], [b0, b1, b2, b3, ..., b15]);
 */

#include <tmmintrin.h>


#include <iostream>

using namespace std;


void display(char* v) {

  for(unsigned int i = 0 ; i < 16 ; ++i) {
    cout << (int)(v[i]) << '\t';
  }
  cout << endl;

}

void display(short* v) {

  for(unsigned int i = 0 ; i < 8 ; ++i) {
    cout << v[i] << '\t';
  }
  cout << endl;

}

int main() {

  char a0[16] __attribute__((aligned(16))) = {2, 4, 6, 8, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15};
  char a1[16] __attribute__((aligned(16))) = {1, 2, 4, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
  char a2[16] __attribute__((aligned(16)));

  __m128i r0, r1, r2;

  display(a0);
  display(a1);

  r0 = _mm_load_si128((__m128i*)a0);
  r1 = _mm_load_si128((__m128i*)a1);

  r2 = _mm_shuffle_epi8(r0, r1);

  _mm_store_si128((__m128i*)a2, r2);

  display(a2);

}
